#include <acknex.h>
#include <default.c>

#include "oggMedia.h"

var pi = 3.14159265;



var fps;




void loadMovies();
int m=0;
function main()
{
	fps_max = 50;
	wait(2);
//	video_window(vector(0, 100, 0), vector(1024, 768,0), 1, "test");
	wait(2);
	video_set(1024, 768, 0, 2);

	level_load("ground.hmp"); 
	wait(3);
	// init oggMedia
	oggM_init(pd3ddev);
	
	
	sun_color.red = 0;
	sun_color.green = 0;
	sun_color.blue = 0;
	d3d_fogcolor1.red = 0;
	d3d_fogcolor1.green = 0;
	d3d_fogcolor1.blue = 0;
	fog_color = 1;
	camera.fog_start = 100;
	camera.fog_end = 500;
	sky_color.red = 0;
	sky_color.green = 0;
	sky_color.blue = 0;
	time_smooth = 0.99;
	
	
	
	wait(1);
	loadMovies();
	var zoom = 0;
	int dest = 0;
	while(1)
	{
		oggM_update();
		camera->x = 0;
		camera->y = 0;
		camera->z = 30;
		camera->pan -= mouse_force.x*time_step*6.0;
		zoom += mickey.z*time_step*0.5;
		zoom = clamp(zoom, 0, 180);
		VECTOR temp;
		vec_for_angle(&temp, camera->pan);
		vec_normalize(&temp, zoom);
		vec_add(camera->x, &temp);
		fps = 16/time_step;
		wait(1);	
	}
}

typedef struct
{
	int hours;
	int minutes;
	double seconds;
} Time;

typedef struct
{
	ENTITY* 	display;
	long		movie;
	Time		length;
	Time		curTime;
	STRING*		fileName;
} Video;


void secondsToTime(Time* t, double seconds)
{
	t->seconds = fmod(seconds, 60.0);
	t->minutes = ((int)seconds/60)%60;
	t->hours = ((int)seconds/3600);
}

TEXT* tDir = 
{ 
	strings = 30; 
	flags = SHOW;
} // empty text with 30 strings

FONT* arial_font = "Arial#12"; // truetype font, 20 point bold characters
void createMovie(STRING* str, int p)
{
	MediaStatus state;
	TheoraInfo tInfo;	
	Video* myVideo = (Video*)malloc(sizeof(Video));
	myVideo->fileName = str;
	
	// create the entity to display the movie
	myVideo->display = ent_create("movieplace.mdl", vector(p*50, p*50, 0), 0);	
	ent_cloneskin(myVideo->display);
	BMAP* bmp_movie = bmap_createblack(4, 4, 24);
	bmap_preload(bmp_movie);
	ent_setskin(myVideo->display, bmp_movie, 0);
	
	
	// open movie
	myVideo->movie = oggM_movieOpen(str->chars, bmp_movie, &tInfo);
	
	// scale the entity according the aspectratio
	myVideo->display->scale_x = (tInfo.width/(double)tInfo.height)*tInfo.aspectRatio;
	myVideo->display->scale_y = 1;
	myVideo->display->scale_z = 1;
	myVideo->display->scale_x *= tInfo.width/1000.0;
	myVideo->display->scale_z *= tInfo.width/1000.0;
	
	
	// get the length of the movie
	secondsToTime(&myVideo->length, oggM_movieLength(myVideo->movie));
	
	// play the movie
	oggM_moviePlay(myVideo->movie);
	
	
	// create panel for displaying filename, movie length, movie time
	PANEL* mov_pan = pan_create(" ", 101);   
	pan_setdigits(mov_pan, 0, 0, 0, myVideo->fileName, arial_font, 1, 0); 	   
	STRING* time_str = str_create("");
	ENTITY* light_ent = ent_create(0, myVideo->display->x, 0);	// for some light effects
	wait(1);
	proc_mode = PROC_LATE;		// otherwise the debug panel would move to slow
	while(1)
	{
	
		// get current time	
		secondsToTime(&myVideo->curTime, oggM_movieTime(myVideo->movie));
		
		// display the time
		str_printf(time_str, "%s   %d:%2.2d:%02.0f/%d:%2.2d:%02.0f", myVideo->fileName->chars, myVideo->curTime.hours, 
						myVideo->curTime.minutes, myVideo->curTime.seconds, myVideo->length.hours, myVideo->length.minutes, 
						myVideo->length.seconds);
		pan_setdigits(mov_pan, 1, 0, 0, time_str, arial_font, 1, 0); 	  
		
		// move the panel above the entity
		VECTOR temp;
		vec_set(&temp,&myVideo->display->x);
		temp.z += 50;		
	   if (NULL != vec_to_screen(&temp,camera)) // if visible on screen
	   {
			set(mov_pan, SHOW);
			mov_pan->pos_x = temp.x-str_width(time_str, arial_font)/2;
			mov_pan->pos_y = temp.y;
		}else	reset(mov_pan, SHOW);
		
		
		// position the entitys in a circle
		myVideo->display->x = cos((2.0*pi/m)*p)*200;
		myVideo->display->y = sin((2.0*pi/m)*p)*200;
		myVideo->display->z = 2;
		myVideo->display->pan = 90+(360.0/m)*p;
		vec_set(light_ent->x, myVideo->display->x);
		light_ent->z += 40;
		
		if (oggM_moviePlaying(myVideo->movie) == 1) {		// display a light if the movie is playing
			light_ent->lightrange = 300;
			light_ent->red = 100;	
			light_ent->green = 100;
			light_ent->green = 100;
		}else
			light_ent->lightrange = 0;
			
		wait(1);	
	}
}


void loadMovies()
{
	m = txt_for_dir(tDir,"*.ogg");  // fill text with 30 file names from the current folder
	int i=0;
	for (i=0; i<m; i++)
	{
		createMovie((tDir->pstring)[i], i);
	}		
	
}